library(SeuratData)
# InstallData("pbmcsca.SeuratData")
library(Seurat)

data("pbmcsca")

pbmcsca
citation('pbmcsca.SeuratData')
str(pbmcsca)

# str(counts(pbmcsca))

names(pbmcsca@meta.data)
table(pbmcsca@meta.data$Experiment)
table(pbmcsca@meta.data$CellType)
table(pbmcsca@meta.data$Method)
table(pbmcsca@meta.data$Method[pbmcsca@meta.data$Experiment == 'pbmc1'])
table(pbmcsca@meta.data$Method[pbmcsca@meta.data$Experiment == 'pbmc2'])
str(pbmcsca@assays$RNA)
str(pbmcsca@assays$RNA@counts)
sum(pbmcsca@assays$RNA@counts != pbmcsca@assays$RNA@data)

gene_name <- rownames(pbmcsca@assays$RNA@counts)
length(gene_name)
nonspikes <- which(!grepl("ercc", gene_name, ignore.case = TRUE))
length(nonspikes)
spikes <- which(grepl("ercc", gene_name, ignore.case = TRUE))
length(spikes)
gene_name[spikes]

mitochon <- which(grepl("^MT-", gene_name, ignore.case = TRUE))
length(mitochon)
gene_name[mitochon]

malat1 <- which(grepl("^MALAT1", gene_name, ignore.case = TRUE))
length(malat1)
gene_name[malat1]

# cell_type_sel <- c('B cell', 'CD14+ monocyte',
#                    'Natural killer cell', 'CD4+ T cell',
#                    'Cytotoxic T cell')

# protocol_list <- c('Drop-seq', '10x Chromium (v2) A', '10x Chromium (v2)',
#                    'Smart-seq2')
# 
# protocol_list_convention <- c('drop-seq', '10x', 'SMART-Seq2')
# 
# exp_sel <- c('pbmc1', 'pbmc2')


# data subsetting -----------------------------------------------------------------
mitochon_l <- grepl("^MT-", gene_name, ignore.case = TRUE)
malat1_l <- grepl("^MALAT1", gene_name, ignore.case = TRUE)
row_sel <- which(!(mitochon_l | malat1_l))

protocol_list <- c('Drop-seq', '10x Chromium (v2)',
                   'Smart-seq2')

protocol_list_convention <- c('drop-seq', '10x', 'SMART-Seq2')

exp_sel <- c('pbmc2')

for(iter1 in 1:length(protocol_list)){
  for(iter2 in 1:length(exp_sel)){
    # data_mat <- readRDS(file = paste0(exp_sel[[iter2]], '_hca_',
    #                                   protocol_list_convention[[iter1]], '.rds'))
    col_sel <- which(pbmcsca@meta.data$Experiment == exp_sel[[iter2]] &
                       pbmcsca@meta.data$Method == protocol_list[[iter1]])
    data_mat <- as.matrix(pbmcsca@assays$RNA@counts[row_sel, col_sel])
    colnames(data_mat) <- pbmcsca@meta.data$CellType[col_sel]
    
    print(exp_sel[[iter2]])
    print(protocol_list[[iter1]])
    cat('number of cells = ', ncol(data_mat), '\n')
    print(table(colnames(data_mat)))
  }
}

for(iter1 in 1:length(protocol_list)){
  for(iter2 in 1:length(exp_sel)){
    col_sel <- which(pbmcsca@meta.data$Experiment == exp_sel[[iter2]] &
                       pbmcsca@meta.data$Method == protocol_list[[iter1]])
    data_mat <- as.matrix(pbmcsca@assays$RNA@counts[row_sel, col_sel])
    colnames(data_mat) <- pbmcsca@meta.data$CellType[col_sel]
    
    saveRDS(data_mat,
            file = paste0(exp_sel[[iter2]], '_hca_',
                          protocol_list_convention[[iter1]], '.rds'))
  }
}













