library(scDesign2)
# source('supp_utils.R')

data_filename_list <- c('pbmc2_hca_drop-seq.rds', 'pbmc2_hca_10x.rds',
                        'pbmc2_hca_SMART-Seq2.rds')
# cell_type_sel <- c('B cell', 'CD14+ monocyte',
#                    'Natural killer cell', 'CD4+ T cell',
#                    'Cytotoxic T cell')
cell_type_sel_list <- matrix(rep(c('B cell', 'CD14+ monocyte',
                                   'Natural killer cell', 'CD4+ T cell',
                                   'Cytotoxic T cell'), length(data_filename_list)),
                             byrow = FALSE, ncol = length(data_filename_list))
cell_type_sel_list
protocol_list <- c('drop-seq', '10x', 'SMART-Seq2')

for(iter1 in 1:length(data_filename_list)){
  data_filename <- data_filename_list[iter1]
  data_mat_original <- readRDS(data_filename)
  cell_type_name <- colnames(data_mat_original)
  
  for(iter2 in 1:nrow(cell_type_sel_list)){
    cell_type_sel <- cell_type_sel_list[iter2, iter1]
    output_suffix <- paste0(protocol_list[iter1], '_', cell_type_sel)
    
    data_mat <- data_mat_original[, cell_type_name == cell_type_sel]
    
    set.seed(1)
    copula_model <- fit_model_scDesign2(data_mat, cell_type_sel)
    saveRDS(copula_model, file = paste0('copula_model_', output_suffix, '.rds'))
  }
}


