library(scDesign2)
# source('supp_utils.R')

# data_filename_list <- c('mouse_retina_drop-seq.rds', 'mouse_sie_10x.rds',
#                         'human_blood.rds')
# cell_type_sel_list <- matrix(c('bipolar', 'cone', 'rod',
#                                'Stem', 'Goblet', 'Tuft',
#                                'DC1', 'DC2', 'Mono2'),
#                              byrow = FALSE, nrow = 3)
data_filename_list <- c('pbmc2_hca_drop-seq.rds', 'pbmc2_hca_10x.rds',
                        'pbmc2_hca_SMART-Seq2.rds')
# cell_type_sel <- c('B cell', 'CD14+ monocyte',
#                    'Natural killer cell', 'CD4+ T cell',
#                    'Cytotoxic T cell')
cell_type_sel_list <- matrix(rep(c('B cell', 'CD14+ monocyte',
                                   'Natural killer cell'), length(data_filename_list)),
                             byrow = FALSE, ncol = length(data_filename_list))
cell_type_sel_list
protocol_list <- c('drop-seq', '10x', 'SMART-Seq2')

for(iter1 in 1:length(data_filename_list)){
  data_filename <- data_filename_list[iter1]
  data_mat_original <- readRDS(data_filename)
  cell_type_name <- colnames(data_mat_original)
  
  for(iter2 in 1:nrow(cell_type_sel_list)){
    cell_type_sel <- cell_type_sel_list[iter2, iter1]
    output_suffix <- paste0(protocol_list[iter1], '_', cell_type_sel)
    
    print(output_suffix)
    
    data_mat <- data_mat_original[, cell_type_name == cell_type_sel]
    cat('cell number =', ncol(data_mat), '\n')
    
    copula_model <- readRDS(file = paste0('copula_model_', output_suffix, '.rds'))
    
    set.seed(1)
    data_sim_copula <- simulate_count_scDesign2(copula_model, ncol(data_mat))
    saveRDS(data_sim_copula, file = paste0('data_sim_copula_', output_suffix, '.rds'))
    
    modified_model <- copula_model
    modified_model[[1]]$marginal_param1[, 1] <- 0.0
    modified_model[[1]]$marginal_param2[, 1] <- 0.0
    set.seed(2)
    data_sim_nozi <- simulate_count_scDesign2(modified_model, ncol(data_mat))
    saveRDS(data_sim_nozi, file = paste0('data_sim_nozi_', output_suffix, '.rds'))
  }
}







