two_state_gex_model <- function(g_init, m_init, k_a, k_i, s_m,
                                delta_m = 1.0, t_factor = 100){
  A <- abs(k_a*s_m/(k_a+k_i)/(k_a+k_i-delta_m))
  t_max <- t_factor * log(A / 0.01)
  
  state <- c(g_init, m_init)
  realization <- list()
  realization[[1]] <- c(0.0, m_init)
  
  iter <- 2
  t_total <- 0.0
  while(t_total < t_max){
    if(state[1] == 0){
      t_i <- rexp(1, k_a)
      t_total <- t_total + t_i
      m <- state[2]
      t_sum <- 0.0
      while(m > 0){
        time_interval <- rexp(1, m*delta_m)
        m <- m - 1
        if(t_sum + time_interval < t_i){
          t_sum <- t_sum + time_interval
          realization[[iter]] <- c(time_interval, m)
          iter <- iter + 1
        }else
          break
      }
      realization[[iter]] <- c(t_i - t_sum, m)
      iter <- iter + 1
      state[1] <- 1
      state[2] <- m
    }else{
      t_a <- rexp(1, k_i)
      t_total <- t_total + t_a
      m <- state[2]
      t_sum <- 0.0
      while(TRUE){
        if(m > 0){
          time_interval <- rexp(1, m*delta_m + s_m)
          if(t_sum + time_interval > t_a)
            break
          else{
            t_sum <- t_sum + time_interval
            reaction_type <- rbinom(1, 1, s_m / (m*delta_m + s_m))
            if(reaction_type == 1)
              m <- m + 1
            else
              m <- m - 1
            realization[[iter]] <- c(time_interval, m)
            iter <- iter + 1
          }
        }else{
          time_interval <- rexp(1, s_m)
          if(t_sum + time_interval > t_a)
            break
          else{
            t_sum <- t_sum + time_interval
            m <- m + 1
            realization[[iter]] <- c(time_interval, m)
            iter <- iter + 1
          }
        }
      }
      realization[[iter]] <- c(t_a - t_sum, m)
      iter <- iter + 1
      state[1] <- 0
      state[2] <- m
    }
  }
  return(list(realization = realization, t_max = t_max))
}



